<template>
  <form class="pa-6">
    <v-text-field
      v-model="state.name"
      :error-messages="v$.name.$errors.map((e) => e.$message)"
      :counter="10"
      label="Name"
      required
      @input="v$.name.$touch"
      @blur="v$.name.$touch"
    ></v-text-field>

    <v-text-field
      v-model="state.email"
      :error-messages="v$.email.$errors.map((e) => e.$message)"
      label="E-mail"
      required
      @input="v$.email.$touch"
      @blur="v$.email.$touch"
    ></v-text-field>

    <v-btn class="me-4" @click="submitForm"> submit </v-btn>
    <v-btn @click="clear"> clear </v-btn>
  </form>
</template>

<script lang="ts" setup>
import { reactive } from 'vue'
import { useVuelidate } from '@vuelidate/core'
import { email, required } from '@vuelidate/validators'
import { useRouter } from 'vue-router'

const initialState = {
  name: '',
  email: '',
}

const state = reactive({
  ...initialState,
})

const rules = {
  name: { required },
  email: { required, email },
}

const v$ = useVuelidate(rules, state)
const router = useRouter()

function clear() {
  v$.value.$reset()

  for (const [key, value] of Object.entries(initialState)) {
    state[key] = value
  }
}

function submitForm() {
  v$.value.$touch() // Trigger validation for all fields

  if (v$.value.$pending) {
    // Do not submit if there are pending validations
    return
  }

  if (v$.value.$invalid) {
    // Handle form errors
    console.log('Form has errors. Cannot submit.')
    return
  }
  // Form is valid, log the values to the console
  console.log('Form values:', state.name, state.email)
  // Navigate to the "/" page after successful submission
  router.push('/') // Replace '/' with the desired route
  // You can also reset the form after logging the values
  clear()
}
</script>
